/**
 * Panel to handle main tabs (tabs container).
 *
 * @class JustKnit.HomePanel
 * @extends MODx.Component
 * @param {Object} config An object of options.
 * @xtype justknit-home-panel
 */

//HomePage
JustKnit.HomePage = function(config) {
    config = config || {};
    Ext.applyIf(config, {
        components: [
            {
                xtype: 'justknit-panel-home'
                ,renderTo: 'justknit-panel-home-div'

            }
        ]
    });
    JustKnit.HomePage.superclass.constructor.call(this, config);
};
Ext.extend(JustKnit.HomePage, MODx.Component);
Ext.reg('justknit-home-page',JustKnit.HomePage);


//HomePanel
JustKnit.HomePanel = function(config) {
    config = config || {};
    Ext.applyIf(config, {
        baseCls: 'modx-formpanel'
//        ,cls: 'main-wrapper'
        ,cls: 'container'
        ,items: [
            {
                html: '<h2>'+_('justknit.management')+'</h2>',  // lexicon: _('justknit.management')
                cls: 'modx-page-header'
            },{
                xtype: 'modx-tabs'
                ,border: true
                ,items: [{
                    xtype: 'justknit-panel-product'//'modx-description'//
                },{
                    xtype: 'justknit-panel-client'
                },{
                    xtype: 'justknit-panel-order'
                },{
                   // xtype:'modx-description'
                   // ,html: 'Los zeig was'
                    xtype: 'justknit-panel-calc'
                },{
                    xtype: 'justknit-panel-dim'
                },{
                    xtype: 'justknit-panel-transaction'
                }/*{
                xtype: 'justknit-panel-categories'
            }*/]
            }
        ]

    });
    JustKnit.HomePanel.superclass.constructor.call(this, config);
};
Ext.extend(JustKnit.HomePanel, MODx.Panel);
Ext.reg('justknit-panel-home',JustKnit.HomePanel);

JustKnit.LapseCombo = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        store: new Ext.data.ArrayStore({
            id: 0
            ,fields: ['Lapse', 'LapseDescription']//['unit','display']
            ,data: [
                ['1month', _('justknit.lapse_1M')]
                ,['3months', _('justknit.lapse_3M')]
                ,['6months', _('justknit.lapse_6M')]
                ,['12months', _('justknit.lapse_12M')]
            ]
        })
        ,mode: 'local'
        ,displayField: 'LapseDescription'
        ,valueField: 'Lapse'
    });
    JustKnit.LapseCombo.superclass.constructor.call(this,config);
};
Ext.extend(JustKnit.LapseCombo,MODx.combo.ComboBox);
Ext.reg('justknit-combo-lapse',JustKnit.LapseCombo);

JustKnit.ProductCombo = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        name: 'product'
        ,hiddenName:'product'
        ,valueField: 'id'
//        id: 1
        ,fields: ['product_name','id']
        ,url: MODx.config.connector_url
//        ,mode: 'local'
        ,baseParams: {
            action: 'JustKnit\\Processors\\Product\\GetList'
        }
//        ,typeAhead: true
//        ,editable: true
    });
    JustKnit.ProductCombo.superclass.constructor.call(this,config);
};
Ext.extend(JustKnit.ProductCombo,MODx.combo.ComboBox);
Ext.reg('justknit-combo-product',JustKnit.ProductCombo);

JustKnit.ResourceCombo = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        name: 'resource_id'
        ,hiddenName:'resource_id'
        ,valueField: 'resource_id'
//        id: 1
        ,fields: ['alias','resource_id']
        ,url: MODx.config.connector_url
//        ,mode: 'local'
        ,baseParams: {
            action: 'JustKnit\\Processors\\Calc\\GetResourceList'
        }
//        ,typeAhead: true
//        ,editable: true
    });
    JustKnit.ResourceCombo.superclass.constructor.call(this,config);
};
Ext.extend(JustKnit.ResourceCombo,MODx.combo.ComboBox);
Ext.reg('justknit-combo-resource',JustKnit.ResourceCombo);

// load HomePage
Ext.onReady(function () {
    MODx.load({ xtype: 'justknit-home-page' });
});
