/**
 * Panel to manage Client.
 *
 * @class JustKnit.panel.Client
 * @extends Ext.Panel
 * @param {Object} config An object of options.
 * @xtype Justknit-panel-client
 */
JustKnit.panel.Client = function(config) {
    config = config || {};
    config.record = config.record || {};
    Ext.applyIf(config,{
        id: 'justknit-panel-client'
        ,title: _('justknit.client')
        ,layout: 'anchor'
        ,defaults: {
            border: false
        }
        ,items:[{
            xtype: 'modx-description'
            ,bodyCssClass: 'panel-desc'
            ,html: '<p>'+_('justknit.client_management_desc')+'</p>'
        }
        ,{
            xtype: 'justknit-grid-client'//'modx-description'//
        }]
    });
    JustKnit.panel.Client.superclass.constructor.call(this,config);
};
Ext.extend(JustKnit.panel.Client,Ext.Panel);
Ext.reg('justknit-panel-client', JustKnit.panel.Client);


//justknit-grid-client
//JustKnit.grid.Client
JustKnit.grid.Client = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        id: 'justknit-grid-client'
        ,url: MODx.config.connector_url
        ,cls: 'main-wrapper'
        ,baseParams: {
            action: 'JustKnit\\Processors\\Client\\GetList'
        }
        ,fields:[
            // JustKnitClientMeta
            'id'
            ,'client_id'
            ,'first_name'
            ,'last_name'
            ,'nick_name'
            ,'buyer_id'
            ,'active_order'
            ,'active_product'
            ,'language'
            ,'country'
            ,'address_id'
            ,'client_deletedafter'
            ,'client_deleted'
            ,'sid'
            // modUser
            ,'username'
            ,'password'
            ,'cachepwd'
            ,'class_key'
            ,'active'
            ,'remote_key'
            ,'remote_data'
            ,'hash_class'
            ,'salt'
            ,'primary_group'
            ,'session_stale'
            ,'sudo'
            ,'createdon'
            // modUserProfile
            ,'internalKey'
            ,'fullname'
            ,'email'
            ,'phone'
            ,'mobilephone'
            ,'blocked'
            ,'blockeduntil'
            ,'blockedafter'
            ,'logincount'
            ,'lastlogin'
            ,'thislogin'
            ,'failedlogincount'
            ,'sessionid'
            ,'dob'
            ,'gender'
            ,'address'
            ,'country'
            ,'city'
            ,'state'
            ,'zip'
            ,'fax'
            ,'photo'
            ,'comment'
            ,'website'
            ,'extended'
        ]
        ,autoHeight: true
        ,paging: true
        ,emptyText: _('justknit.client_none')
        ,remoteSort: true
        ,save_action: 'JustKnit\\Processors\\Client\\UpdateFromGrid'
        ,autosave: true
        ,columns: [
            // JustKnitClientMeta
            { header: _('justknit.id') ,dataIndex: 'id' ,sortable: true, width: .15  }
            ,{ header: _('justknit.client_id') ,dataIndex: 'client_id' ,sortable: true, width: .15 ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.username') ,dataIndex: 'username' ,sortable: true }
            ,{ header: _('justknit.active') ,dataIndex: 'active' ,sortable: true, width: .15 ,editor: {xtype: 'combo-boolean',renderer: 'boolean'} }
            ,{ header: _('justknit.blocked') ,dataIndex: 'blocked' ,sortable: true, width: .20 ,editor: {xtype: 'combo-boolean',renderer: 'boolean'} }
            ,{ header: _('justknit.email') ,dataIndex: 'email' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.active_product') ,dataIndex: 'active_product' ,sortable: true ,editor: { xtype: 'justknit-combo-product', hiddenName: 'active_product',displayField: 'product_name',renderer: true } }
            ,{ header: _('justknit.active_order') ,dataIndex: 'active_order' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.primary_group') ,dataIndex: 'primary_group' ,sortable: true , editor: { xtype: 'modx-combo-usergroup', renderer: true }}
            ,{ header: _('justknit.createdon') ,dataIndex: 'createdon' ,sortable: true,renderer : Ext.util.Format.dateRenderer('d.m.Y H:i')  }
            ,{ header: _('justknit.blockedafter') ,dataIndex: 'blockedafter' ,sortable: true }
            ,{ header: _('justknit.client_deletedafter') ,dataIndex: 'client_deletedafter' ,sortable: true ,renderer : Ext.util.Format.dateRenderer('d.m.Y')}
            ,{ header: _('justknit.logincount') ,dataIndex: 'logincount' ,sortable: true  }
            ,{ header: _('justknit.comment') ,dataIndex: 'comment' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.first_name') ,dataIndex: 'first_name' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.last_name') ,dataIndex: 'last_name' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.nick_name') ,dataIndex: 'nick_name' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.buyer_id') ,dataIndex: 'buyer_id' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.active_order') ,dataIndex: 'active_order' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.active_product') ,dataIndex: 'active_product' ,sortable: true ,editor: { xtype: 'justknit-combo-product', hiddenName: 'active_product',displayField: 'product_name',renderer: true } }
            //,{ header: _('justknit.language') ,dataIndex: 'language' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.country') ,dataIndex: 'country' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.address_id') ,dataIndex: 'address_id' ,sortable: true ,editor: {xtype: 'textfield'} } MODx.config.manager_date_format
            //,{ header: _('justknit.client_deletedafter') ,dataIndex: 'client_deletedafter' ,sortable: true ,renderer : Ext.util.Format.dateRenderer('d.m.Y')}
            //,{ header: _('justknit.client_deleted') ,dataIndex: 'client_deleted' ,sortable: true ,editor: {xtype: 'combo-boolean',renderer: 'boolean'} }
            //,{ header: _('justknit.sid') ,dataIndex: 'sid' ,sortable: true ,editor: {xtype: 'textfield'} }

            // modUser
            //,{ header: _('justknit.username') ,dataIndex: 'username' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.password') ,dataIndex: 'password' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.cachepwd') ,dataIndex: 'cachepwd' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.class_key') ,dataIndex: 'class_key' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.active') ,dataIndex: 'active' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.remote_key') ,dataIndex: 'remote_key' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.remote_data') ,dataIndex: 'remote_data' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.hash_class') ,dataIndex: 'hash_class' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.salt') ,dataIndex: 'salt' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.primary_group') ,dataIndex: 'primary_group' ,sortable: true , editor: { xtype: 'modx-combo-usergroup', renderer: true }}
            //,{ header: _('justknit.session_stale') ,dataIndex: 'session_stale' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.sudo') ,dataIndex: 'sudo' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.createdon') ,dataIndex: 'createdon' ,renderer : Ext.util.Format.dateRenderer('d.m.Y'),sortable: true  }

            // modUserProfile
            //,{ header: _('justknit.internalKey') ,dataIndex: 'internalKey' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.fullname') ,dataIndex: 'fullname' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.email') ,dataIndex: 'email' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.phone') ,dataIndex: 'phone' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.mobilephone') ,dataIndex: 'mobilephone' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.blocked') ,dataIndex: 'blocked' ,sortable: true ,editor: {xtype: 'combo-boolean',renderer: 'boolean'} }
            //,{ header: _('justknit.blockeduntil') ,dataIndex: 'blockeduntil' ,sortable: true ,editor: {xtype: 'textfield'} }datefield,editor: {xtype: 'xdatetime',renderer: true}
            //,{ header: _('justknit.blockedafter') ,dataIndex: 'blockedafter' ,sortable: true }
            //,{ header: _('justknit.logincount') ,dataIndex: 'logincount' ,sortable: true  }
            //,{ header: _('justknit.lastlogin') ,dataIndex: 'lastlogin' ,sortable: true ,editor: {xtype: 'textfield'} },renderer : Ext.util.Format.dateRenderer('Y-m-d')
            //,{ header: _('justknit.thislogin') ,dataIndex: 'thislogin' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.failedlogincount') ,dataIndex: 'failedlogincount' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.sessionid') ,dataIndex: 'sessionid' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.dob') ,dataIndex: 'dob' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.gender') ,dataIndex: 'gender' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.address') ,dataIndex: 'address' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.country') ,dataIndex: 'country' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.city') ,dataIndex: 'city' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.state') ,dataIndex: 'state' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.zip') ,dataIndex: 'zip' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.fax') ,dataIndex: 'fax' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.photo') ,dataIndex: 'photo' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.comment') ,dataIndex: 'comment' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.website') ,dataIndex: 'website' ,sortable: true ,editor: {xtype: 'textfield'} }
            //,{ header: _('justknit.extended') ,dataIndex: 'extended' ,sortable: true ,editor: {xtype: 'textfield'} }
        ]
        ,tbar:[
            {
                text: _('justknit.client_create')
                ,handler: this.createClient
                ,scope: this
            },'->',{
                xtype: 'modx-combo-usergroup'
                ,id: 'justknit-clients-group-filter'
                ,emptyText: _('justknit.clients_user_group_filter')
                ,name: 'fltr_user_group'
                ,hiddenName: 'fltr_user_group'
                ,displayField: 'name'
                ,valueField: 'id'
//                store: new Ext.data.ArrayStore({
//                })
                ,listeners: {
                    'select': {fn: this.filterByUserGroup, scope: this}
                }

            }
            ,{text: _('justknit.client_blocked_filter')
                ,handler: this.filterIsBlockedAfter
                ,scope: this
            }
            ,{text: _('justknit.client_thislogin')
                ,handler: this.filterThisLogin
                ,scope: this
            }
            ,{
                text: _('justknit.reset_filter')
                ,handler: this.clearFilter
                ,scope: this
            }
            ,{
            xtype: 'textfield',
            emptyText: _('justknit.input_search_filter'),
            listeners: {
                'change': {fn: this.search, scope: this}
            }
        }
        ]
    });
    JustKnit.grid.Client.superclass.constructor.call(this, config);
};
Ext.extend(JustKnit.grid.Client, MODx.grid.Grid, {
    search: function(tf,nv,ov) {
        var s = this.getStore();
        s.baseParams.query = tf.getValue();
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
    ,clearFilter: function() {
    	this.getStore().baseParams = {
            action: 'JustKnit\\Processors\\Client\\GetList'
    	};
        Ext.getCmp('justknit-clients-group-filter').reset();
//        Ext.getCmp('justknit-clients-category-filter').reset();
//        Ext.getCmp('goodnews-clients-testdummy-filter').reset();
//        Ext.getCmp('goodnews-clients-active-filter').reset();
//        Ext.getCmp('goodnews-clients-search-filter').reset();
    	this.getBottomToolbar().changePage(1);
    }
    ,createClient: function(btn, e) {
        var win = MODx.load({
            xtype: 'justknit-window-client-create-update'
            ,title: _('justknit.client_create')
            ,listeners: {
                'success': {fn: function() {this.refresh();}, scope: this}
            }
        });
        win.show(e.target);
    }
    ,updateClient: function(btn, e) {
        if (!this.menu.record || !this.menu.record.id){
            return false;
        }
        var win = MODx.load({
            xtype: 'justknit-window-client-create-update'
            ,title: _('justknit.client_update')
            ,record: this.menu.record
            ,action: 'JustKnit\\Processors\\Client\\Update'
            ,listeners: {
                'success': {fn: function() {this.refresh();}, scope: this}
            }
        });
        win.fp.getForm().setValues(this.menu.record);
        win.show(e.target);
    }
    ,getMenu:function() {
        var m = [];
        m.push({
            text: _('justknit.client_update')
            ,handler: this.updateClient
        });
        m.push({
            text: _('justknit.client_remove')
            ,handler: this.removeClient
        });
        m.push('-');
        m.push({
            text: _('justknit.user_edit')
            ,handler: this.editUser
        });
        this.addContextMenuItem(m);

    }
    ,removeClient: function(btn, e) {
        if (!this.menu.record){
            return false;
        }
        MODx.msg.confirm({
            title: _('justknit.client_remove')
            ,text: _('justknit.client_remove_confirm')
            ,url: this.config.url
            ,params: {
                action: 'JustKnit\\Processors\\Client\\Remove'
                ,id: this.menu.record.id
            }
            ,listeners:{
                'success': { fn: function() {this.refresh();}, scope: this}
            }
        });
    }
    ,editUser:function(btn,e) {
        MODx.loadPage('security/user/update', 'id=' + this.menu.record.client_id);
    }
    ,filterByUserGroup: function(combo) {
//        var s = [];
//        Ext.getCmp('justknit-clients-group-filter').reset();
//        var s = Ext.getCmp('justknit-clients-group-filter');
//        s.baseParams.groupfilter = combo.getValue();
//        s.baseParams.groupfilter = Ext.getCmp('justknit-clients-group-filter').getValue();
        var s = this.getStore();
        s.baseParams.groupfilter = combo.getValue();
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
    ,filterIsBlockedAfter:function(btn, e){
        var s = this.getStore();
        s.baseParams.blockedafterfilter = true;
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
    ,filterThisLogin:function(btn, e){
        var s = this.getStore();
        s.baseParams.thisloginfilter = true;
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
});
Ext.reg('justknit-grid-client', JustKnit.grid.Client);

// JustKnit.window.CreateUpdateClient
JustKnit.window.CreateUpdateClient = function(config) {
    config = config || {};
    config = config || {record:{}};
    Ext.applyIf(config, {
         width: 700
        ,closeAction: 'close'
        ,url: MODx.config.connector_url
        ,preventRender: true
        ,action: 'JustKnit\\Processors\\Client\\Create'
        ,fields : [
            new Ext.Panel ({
                layout:"column"
                ,defaults:{layout:'form',style:'margin:0'}
                ,items:[
                    // JustKnitClientMeta
                    {columnWidth:.3,items:[{xtype: 'hidden',fieldLabel: _('justknit.id') ,name: 'id'}]}
                    ,{columnWidth:.3,items:[{xtype: 'hidden',fieldLabel: _('justknit.internalKey') ,name: 'internalKey'}]}

                    ,{columnWidth:.3,items:[{xtype: 'textfield',disabled :true,fieldLabel: _('justknit.client_id') ,name: 'client_id'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',cls:'green',fieldLabel: _('justknit.email') ,name: 'email'}]}
                    ,{columnWidth:.3,items:[{xtype: 'modx-combo-usergroup',cls:'red',fieldLabel: _('justknit.primary_group'),emptyText: _('justknit.product_modxusergroup'),displayField: 'name' ,hiddenName: 'primary_group',name: 'primary_group'}]}

                    ,{columnWidth:.3,items:[{xtype: 'justknit-combo-product' ,hiddenName: 'active_product',displayField: 'product_name',fieldLabel: _('justknit.active_product') ,name: 'active_product'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',disabled :true,fieldLabel: _('justknit.logincount') ,name: 'logincount'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.active_order') ,name: 'active_order'}]}

                    ,{columnWidth:.3,items:[{xtype: 'checkbox',cls:'red',hideLabel: true ,inputValue: 1,boxLabel: _('justknit.active'),name: 'active' ,checked: parseInt(config.record.active)}]}
                    ,{columnWidth:.3,items:[{xtype: 'checkbox',cls:'green',hideLabel: true ,inputValue: 1,boxLabel: _('justknit.blocked'),name: 'blocked',checked: parseInt(config.record.blocked)}]}
                    ,{columnWidth:.3,items:[{xtype: 'checkbox',cls:'blue' ,hideLabel: true ,inputValue: 1,boxLabel: _('justknit.client_deleted'),value: 'client_deleted' ,name: 'client_deleted',checked: parseInt(config.record.client_deleted)}]}

                    ,{columnWidth:.3,items:[{name: 'createdon'          ,cls:'red'  ,fieldLabel: _('justknit.createdon'), disabled: true
                        ,xtype: 'xdatetime'     ,allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}
                    ,{columnWidth:.3,items:[{name: 'blockedafter'       ,cls:'green',fieldLabel: _('justknit.blockedafter')
                        ,xtype: 'xdatetime',hiddenFormat: 'd.m.Y H:i',allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}
                    ,{columnWidth:.3,items:[{name: 'client_deletedafter',cls:'blue' ,fieldLabel: _('justknit.client_deletedafter')
                        ,xtype: 'xdatetime',hiddenFormat: 'd.m.Y H:i',allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}

                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.language') ,name: 'language'}]}
                    ,{columnWidth:.3,items:[{xtype: 'modx-combo-country',fieldLabel: _('justknit.country') ,name: 'country',displayField: 'country'}]}
                    ,{columnWidth:.3,items:[{fieldLabel: _('justknit.lastlogin') ,name: 'lastlogin',disabled :true
                        ,xtype: 'xdatetime',hiddenFormat: 'd.m.Y H:i',allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}

                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.address') ,name: 'address'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.zip') ,name: 'zip'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.city') ,name: 'city'}]}

                    ,{columnWidth:.3,items:[{xtype: 'modx-combo-gender',width: 150,fieldLabel: _('justknit.gender') ,name: 'gender',hiddenName: 'gender'}]}
                    //,name: 'gender',hiddenName: 'gender',fieldLabel: _('user_gender'),xtype: 'modx-combo-gender'
                //    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.country') ,name: 'country'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.address_id') ,name: 'address_id'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',cls:'red',disabled :true,fieldLabel: _('justknit.username') ,name: 'username'}]}

                    ,{columnWidth:.6,items:[{xtype: 'textfield',cls:'green',anchor: '95%',fieldLabel: _('justknit.comment') ,name: 'comment'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.buyer_id') ,name: 'buyer_id'}]}

                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.first_name') ,name: 'first_name'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.last_name') ,name: 'last_name'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.nick_name') ,name: 'nick_name'}]}



//,xtype: 'modx-combo-gender'
// JustKnitClientMeta
//,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.client_deletedafter') ,name: 'client_deletedafter'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.sid') ,name: 'sid'}]}

// modUser
//                    ,{columnWidth:.3,items:[{xtype: 'textfield',cls:'red',disabled :true,fieldLabel: _('justknit.username') ,name: 'username'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.password') ,name: 'password'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.cachepwd') ,name: 'cachepwd'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.class_key') ,name: 'class_key'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.remote_key') ,name: 'remote_key'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.remote_data') ,name: 'remote_data'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.hash_class') ,name: 'hash_class'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.salt') ,name: 'salt'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.session_stale') ,name: 'session_stale'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.sudo') ,name: 'sudo'}]}
//,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.createdon') ,name: 'createdon'}]}


// modUserProfile
//                    ,{columnWidth:.3,items:[{xtype: 'textfield',cls:'green',fieldLabel: _('justknit.fullname') ,name: 'fullname'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.phone') ,name: 'phone'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.state') ,name: 'state'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.mobilephone') ,name: 'mobilephone'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.blockeduntil') ,name: 'blockeduntil'}]}
//,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.blockedafter') ,name: 'blockedafter'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.thislogin') ,name: 'thislogin'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.failedlogincount') ,name: 'failedlogincount'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.sessionid') ,name: 'sessionid'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.dob') ,name: 'dob'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.fax') ,name: 'fax'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.photo') ,name: 'photo'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.website') ,name: 'website'}]}
//    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.extended') ,name: 'extended'}]}

                ]
            })
        ]
    });
    JustKnit.window.CreateUpdateClient.superclass.constructor.call(this, config);
    console.log('parseInt(config.active)'+parseInt(config.active));
    console.log('parseInt(config.record.active)'+parseInt(config.record.active));
};
Ext.extend(JustKnit.window.CreateUpdateClient, MODx.Window);
Ext.reg('justknit-window-client-create-update', JustKnit.window.CreateUpdateClient);





