/**
 * Panel to manage Subscriber.
 *
 * @class JustKnit.panel.Subscriber
 * @extends Ext.Panel
 * @param {Object} config An object of options.
 * @xtype Justknit-panel-subscriber
 */
JustKnit.panel.Subscriber = function(config) {
    config = config || {};
    config.record = config.record || {};
    Ext.applyIf(config,{
        id: 'justknit-panel-subscriber'
        ,title: _('justknit.subscriber')
        ,layout: 'anchor'
        ,defaults: {
            border: false
        }
        ,items:[{
            xtype: 'modx-description'
            ,bodyCssClass: 'panel-desc'
            ,html: '<p>'+_('justknit.subscriber_management_desc')+'</p>'
        }
/*        ,{
            xtype: 'modx-description'//'justknit-grid-subscriber'//
            ,html: '<p>Los zeig was an!!</p>'
        },
*/
        ,{
            xtype: 'justknit-grid-subscriber'//'modx-description'//
        }]
    });
    JustKnit.panel.Subscriber.superclass.constructor.call(this,config);
};
Ext.extend(JustKnit.panel.Subscriber,Ext.Panel);
Ext.reg('justknit-panel-subscriber', JustKnit.panel.Subscriber);


//justknit-grid-subscriber
//JustKnit.grid.Subscriber
JustKnit.grid.Subscriber = function(config) {
    config = config || {};
    Ext.applyIf(config,{
        id: 'justknit-grid-subscriber'
        ,url: MODx.config.connector_url
        ,cls: 'main-wrapper'
        ,baseParams: {
            action: 'JustKnit\\Processors\\Subscriber\\GetList'
        }
        ,fields:[
            'username'
            ,'active'
            ,'primary_group'
            ,'internalKey'
            ,'fullname'
            ,'email'
            ,'blocked'
            ,'blockedafter'
            ,'logincount'
            ,'lastlogin'
            ,'thislogin'
            ,'failedlogincount'
            ,'comment'
            ,'id'
            ,'subscriber_id'
            ,'first_name'
            ,'last_name'
            ,'nick_name'
            ,'buyer_id'
            ,'active_order'
            ,'active_product'
            ,'language'
            ,'country'
            ,'address_id'
            ,'subscriber_blocked'
            ,'subscriber_deletedafter'
            ,'subscriber_deleted'
            ,'sid'
        ]
        ,autoHeight: true
        ,paging: true
        ,emptyText: _('justknit.subscriber_none')
        ,remoteSort: true
        ,save_action: 'JustKnit\\Processors\\Subscriber\\UpdateFromGrid'
        ,autosave: true
        ,columns: [
            { header: _('justknit.subscriber_id') ,dataIndex: 'subscriber_id' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.email') ,dataIndex: 'email' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.username') ,dataIndex: 'username' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{header: _('justknit.primary_group'),dataIndex: 'primary_group',sortable: true, editor: { xtype: 'modx-combo-usergroup', renderer: true }}
            ,{ header: _('justknit.active') ,dataIndex: 'active' ,sortable: true ,editor: {xtype: 'combo-boolean',renderer: 'boolean'}}
//            ,{ header: _('justknit.internalKey') ,dataIndex: 'internalKey' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.fullname') ,dataIndex: 'fullname' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.blocked') ,dataIndex: 'blocked' ,sortable: true ,editor: {xtype: 'combo-boolean',renderer: 'boolean'}}
            ,{ header: _('justknit.blockedafter') ,dataIndex: 'blockedafter' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.logincount') ,dataIndex: 'logincount' ,sortable: true /*,editor: {xtype: 'textfield'} */}
            ,{ header: _('justknit.lastlogin') ,dataIndex: 'lastlogin' ,sortable: true /*,editor: {xtype: 'textfield'} */}
            ,{ header: _('justknit.failedlogincount') ,dataIndex: 'failedlogincount' ,sortable: true /*,editor: {xtype: 'textfield'} */}
            ,{ header: _('justknit.comment') ,dataIndex: 'comment' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.id') ,dataIndex: 'id' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.first_name') ,dataIndex: 'first_name' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.last_name') ,dataIndex: 'last_name' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.nick_name') ,dataIndex: 'nick_name' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.sid') ,dataIndex: 'sid' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.active_order') ,dataIndex: 'active_order' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.active_product') ,dataIndex: 'active_product' ,sortable: true ,editor: { xtype: 'justknit-combo-product', hiddenName: 'active_product',displayField: 'product_name',renderer: true } }
            ,{ header: _('justknit.subscribedon') ,dataIndex: 'subscribedon' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.activatedon') ,dataIndex: 'activatedon' ,sortable: true ,editor: {xtype: 'textfield'} }
            ,{ header: _('justknit.subscriber_blockedafter') ,dataIndex: 'subscriber_blockedafter' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.subscriber_blocked') ,dataIndex: 'subscriber_blocked' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.subscriber_deletedafter') ,dataIndex: 'subscriber_deletedafter' ,sortable: true ,editor: {xtype: 'textfield'} }
//            ,{ header: _('justknit.subscriber_deleted') ,dataIndex: 'subscriber_deleted' ,sortable: true ,editor: {xtype: 'textfield'} }
/*            {
                header: _('justknit.subscriber_s_id')
                ,dataIndex: 'id'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_id')
                ,dataIndex: 'subscriber_id'
                , sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.internalKey')
                ,dataIndex: 'internalKey', sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_first_name')
                ,dataIndex: 'first_name'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_last_name')
                ,dataIndex: 'last_name'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_nick_name')
                ,dataIndex: 'nick_name'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_email')
                ,dataIndex: 'email'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_sid')
                ,dataIndex: 'sid'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_active_order')
                ,dataIndex: 'active_order'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_active_product')
                ,dataIndex: 'active_product'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_subscribedon')
                ,dataIndex: 'subscribedon'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_activatedon')
                ,dataIndex: 'activatedon'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_blockedafter')
                ,dataIndex: 'subscriber_blockedafter'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.subscriber_blocked')
                ,dataIndex: 'subscriber_blocked'
                ,sortable: true
                ,editable: true
                ,editor: {
                    xtype: 'combo-boolean'
                    ,renderer: 'boolean'
                }
            }
            ,{
                header: _('justknit.subscriber_deletedafter')
                ,dataIndex: 'subscriber_deletedafter'
                ,sortable: true
                ,editor: {xtype: 'textfield'}
            }
            ,{
                header: _('justknit.user_blocked')
                ,dataIndex: 'blocked'
                ,sortable: true
                ,editable: true
                ,editor: {
                    xtype: 'combo-boolean'
                    ,renderer: 'boolean'
                }
            }*/
        ]
        ,tbar:[
            {
                text: _('justknit.subscriber_create')
                ,handler: this.createSubscriber
                ,scope: this
            },'->',{
                xtype: 'modx-combo-usergroup'
                ,id: 'justknit-subscribers-group-filter'
                ,emptyText: _('justknit.subscribers_user_group_filter')
                ,name: 'fltr_user_group'
                ,hiddenName: 'fltr_user_group'
                ,displayField: 'name'
                ,valueField: 'id'
//                store: new Ext.data.ArrayStore({
//                })
                ,listeners: {
                    'select': {fn: this.filterByUserGroup, scope: this}
                }
//            xtype: 'modx-description'
//            ,html: '<p>Los zeig was an!!</p>'
            }
            ,{text: _('justknit.subscriber_blocked_filter')
                ,handler: this.filterIsBlockedAfter
                ,scope: this
            }
            ,{text: _('justknit.subscriber_thislogin')
                ,handler: this.filterThisLogin
                ,scope: this
            }
            ,{
                text: _('justknit.reset_filter')
                ,handler: this.clearFilter
                ,scope: this
            }
            ,{
            xtype: 'textfield',
            emptyText: _('justknit.input_search_filter'),
            listeners: {
                'change': {fn: this.search, scope: this}
            }
        }
        ]
    });
    JustKnit.grid.Subscriber.superclass.constructor.call(this, config);
};
Ext.extend(JustKnit.grid.Subscriber, MODx.grid.Grid, {
    search: function(tf,nv,ov) {
        var s = this.getStore();
        s.baseParams.query = tf.getValue();
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
    ,clearFilter: function() {
    	this.getStore().baseParams = {
            action: 'JustKnit\\Processors\\Subscriber\\GetList'
    	};
        Ext.getCmp('justknit-subscribers-group-filter').reset();
//        Ext.getCmp('justknit-subscribers-category-filter').reset();
//        Ext.getCmp('goodnews-subscribers-testdummy-filter').reset();
//        Ext.getCmp('goodnews-subscribers-active-filter').reset();
//        Ext.getCmp('goodnews-subscribers-search-filter').reset();
    	this.getBottomToolbar().changePage(1);
    }
    ,createSubscriber: function(btn, e) {
        var win = MODx.load({
            xtype: 'justknit-window-subscriber-create-update'
            ,title: _('justknit.subscriber_create')
            ,listeners: {
                'success': {fn: function() {this.refresh();}, scope: this}
            }
        });
        win.show(e.target);
    }
    ,updateSubscriber: function(btn, e) {
        if (!this.menu.record || !this.menu.record.id){
            return false;
        }
        var win = MODx.load({
            xtype: 'justknit-window-subscriber-create-update'
            ,title: _('justknit.subscriber_update')
            ,record: this.menu.record
            ,action: 'JustKnit\\Processors\\Subscriber\\Update'
            ,listeners: {
                'success': {fn: function() {this.refresh();}, scope: this}
            }
        });
        win.fp.getForm().setValues(this.menu.record);
        win.show(e.target);
    }
    ,getMenu:function() {
        var m = [];
        m.push({
            text: _('justknit.subscriber_update')
            ,handler: this.updateSubscriber
        });
        m.push({
            text: _('justknit.subscriber_remove')
            ,handler: this.removeSubscriber
        });
        m.push('-');
        m.push({
            text: _('justknit.user_edit')
            ,handler: this.editUser
        });
        this.addContextMenuItem(m);

    }
    ,removeSubscriber: function(btn, e) {
        if (!this.menu.record){
            return false;
        }
        MODx.msg.confirm({
            title: _('justknit.subscriber_remove')
            ,text: _('justknit.subscriber_remove_confirm')
            ,url: this.config.url
            ,params: {
                action: 'JustKnit\\Processors\\Subscriber\\Remove'
                ,id: this.menu.record.id
            }
            ,listeners:{
                'success': { fn: function() {this.refresh();}, scope: this}
            }
        });
    }
    ,editUser:function(btn,e) {
        MODx.loadPage('security/user/update', 'id=' + this.menu.record.subscriber_id);
    }
    ,filterByUserGroup: function(combo) {
//        var s = [];
//        Ext.getCmp('justknit-subscribers-group-filter').reset();
//        var s = Ext.getCmp('justknit-subscribers-group-filter');
//        s.baseParams.groupfilter = combo.getValue();
//        s.baseParams.groupfilter = Ext.getCmp('justknit-subscribers-group-filter').getValue();
        var s = this.getStore();
        s.baseParams.groupfilter = combo.getValue();
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
    ,filterIsBlockedAfter:function(btn, e){
        var s = this.getStore();
        s.baseParams.blockedafterfilter = true;
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
    ,filterThisLogin:function(btn, e){
        var s = this.getStore();
        s.baseParams.thisloginfilter = true;
        this.getBottomToolbar().changePage(1);
        this.refresh();
    }
});
Ext.reg('justknit-grid-subscriber', JustKnit.grid.Subscriber);

// JustKnit.window.CreateUpdateSubscriber
JustKnit.window.CreateUpdateSubscriber = function(config) {
    config = config || {};
    config = config || {record:{}};
    Ext.applyIf(config, {
         width: 700
        ,closeAction: 'close'
        ,url: MODx.config.connector_url
        ,preventRender: true
        ,action: 'JustKnit\\Processors\\Subscriber\\Create'
        ,fields : [
            new Ext.Panel ({
                layout:"column"
                ,defaults:{layout:'form',style:'margin:0'}
                ,items:[
                    {columnWidth:.3,items:[{xtype: 'hidden' ,fieldLabel: _('justknit.id') ,name: 'id'}]}
                    
                    ,{columnWidth:.3,items:[{xtype: 'textfield',cls:'red'  ,fieldLabel: _('justknit.username') ,name: 'username'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',cls:'green',fieldLabel: _('justknit.email')    ,name: 'email'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',cls:'green',fieldLabel: _('justknit.fullname') ,name: 'fullname'}]}
                    
                    ,{columnWidth:.3,items:[{xtype: 'checkbox',cls:'red',hideLabel: true ,inputValue: 1,boxLabel: _('justknit.active'),name: 'active' ,checked: parseInt(config.record.active)}]}
                    ,{columnWidth:.3,items:[{xtype: 'modx-combo-usergroup' ,cls:'red',fieldLabel: _('justknit.primary_group'),emptyText: _('justknit.product_modxusergroup'),displayField: 'name' ,hiddenName: 'primary_group',name: 'primary_group'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield',fieldLabel: _('justknit.subscriber_id') ,name: 'subscriber_id'}]}
                    
                    ,{columnWidth:.3,items:[{id: 'justknit-blocked',boxLabel: _('justknit.blocked'),hideLabel: true,value: 'blocked',name: 'blocked',checked: parseInt(config.blocked)
                        ,xtype: 'checkbox',inputValue: 1
                        ,listeners: {
                            'beforerender': {
                                fn: function (e) {
                                    let blockedafter = Ext.getCmp('justknit-blockedafter');
                                    let s_blockedafter = Ext.getCmp('justknit-subscriber-blockedafter');
                                    if (e.checked) {
                                        blockedafter.disable();
                                        s_blockedafter.disable();
                                    } else {
                                        blockedafter.enable();
                                        s_blockedafter.enable();
                                    }
                                }//,scope: this
                            }
                            ,'check': {
                                fn: function (e, checked) {
                                    let blockedafter = Ext.getCmp('justknit-blockedafter');
                                    let s_blockedafter = Ext.getCmp('justknit-subscriber-blockedafter');
                                    if (checked) {
                                        blockedafter.enable();
                                        s_blockedafter.enable();
                                        //Ext.getCmp('justknit-blocked').setValue.checked(true);
                                    } else {
                                        blockedafter.disable();
                                        s_blockedafter.disable();
                                        //Ext.getCmp('justknit-blockedafter').setValue(null);
                                        //Ext.getCmp('justknit-subscriber-blockedafter').setValue(null);
                                    }
                                }
                                ,scope: this
                            }
                        }
                    }]}
                    ,{columnWidth:.3,items:[{id: 'justknit-subscriber-blocked',xtype: 'checkbox' ,hideLabel: true ,inputValue: 1,boxLabel: _('justknit.subscriber_blocked'),value: 'subscriber_blocked' ,name: 'subscriber_blocked',checked: parseInt(config.record.subscriber_blocked)}]}
                    ,{columnWidth:.3,items:[{xtype: 'checkbox' ,hideLabel: true ,inputValue: 1,boxLabel: _('justknit.subscriber_deleted'),value: 'subscriber_deleted' ,name: 'subscriber_deleted',checked: parseInt(config.record.subscriber_deleted)}]}
/*
 * Änderung bei checkbox check
 *

            ,xtype: 'xcheckbox'
            ,inputValue: 1
            ,listeners: {
                'check': {
                    fn: function (e, checked) {
                        let blockeduntil = Ext.getCmp('modx-user-blockeduntil');
                        if (checked) {
                            blockeduntil.enable();
                        } else {
                            blockeduntil.disable();
                            Ext.getCmp('modx-user-blockedafter').setValue(null);
                        }
                    }
                    ,scope: this
                }
            }
*/

                    ,{columnWidth:.3,items:[{id: 'justknit-blockedafter',name: 'blockedafter',fieldLabel: _('justknit.blockedafter'),cls:'green'
                        ,xtype: 'xdatetime', allowBlank: true, dateFormat: MODx.config.manager_date_format, timeFormat: MODx.config.manager_time_format
                        /*,offset_time: MODx.config.server_offset_time, startDay: parseInt(MODx.config.manager_week_start)*/,width: 250,dateWidth: 150}]}
                    ,{columnWidth:.3,items:[{id: 'justknit-subscriber-blockedafter',name: 'subscriber_blockedafter',fieldLabel: _('justknit.subscriber_blockedafter')
                        ,xtype: 'xdatetime',allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format
                        ,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}
/*

                        ,xtype: 'datefield'
                        ,allowBlank: true
                        ,format: MODx.config.manager_date_format

{
                        xtype: 'textfield'
                        ,cls:'green'
                        ,fieldLabel: _('justknit.blockedafter')
                        ,name: 'blockedafter'}
{
                    id: 'modx-user-dob'
                    ,name: 'dob'
                    ,fieldLabel: _('user_dob')
                    ,xtype: 'datefield'
                    ,anchor: '100%'
                    ,allowBlank: true
                    ,format: MODx.config.manager_date_format
                }


{
            id: 'modx-user-blockedafter'
            ,name: 'blockedafter'
            ,fieldLabel: _('user_blockedafter')
            ,description: _('user_blockedafter_desc')
            ,xtype: 'xdatetime'
            ,width: 300
            ,timeWidth: 150
            ,dateWidth: 150
            ,allowBlank: true
            ,dateFormat: MODx.config.manager_date_format
            ,timeFormat: MODx.config.manager_time_format
            ,hiddenFormat: 'Y-m-d H:i:s'
        }

*           ,allowBlank: true
            ,xtype: 'xdatetime'
            ,dateFormat: MODx.config.manager_date_format
            ,timeFormat: MODx.config.manager_time_format
            ,dateWidth: 120
            ,timeWidth: 120
            ,value: config.record.pattern.pcreatedon
            ,offset_time: MODx.config.server_offset_time
            ,startDay: parseInt(MODx.config.manager_week_start)
 */
                    ,{columnWidth:.3,items:[{name: 'subscriber_deletedafter',fieldLabel: _('justknit.subscriber_deletedafter')
                        ,xtype: 'xdatetime',allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format
                        ,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield' ,fieldLabel: _('justknit.active_order') ,name: 'active_order'}]}
                    ,{columnWidth:.3,items:[{xtype: 'justknit-combo-product' ,hiddenName: 'active_product',displayField: 'product_name',fieldLabel: _('justknit.active_product') ,name: 'active_product'}]}
                    ,{columnWidth:.3,items:[{name: 'subscribedon' ,fieldLabel: _('justknit.subscribedon')
                        ,xtype: 'xdatetime',allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format
                        ,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}
                    
                    ,{columnWidth:.6,items:[{xtype: 'textfield',cls:'green',anchor: '95%' ,fieldLabel: _('justknit.comment') ,name: 'comment'}]}
                    ,{columnWidth:.3,items:[{name: 'activatedon' ,fieldLabel: _('justknit.activatedon')
                        ,xtype: 'xdatetime',allowBlank: true,dateFormat: MODx.config.manager_date_format,timeFormat: MODx.config.manager_time_format
                        ,offset_time: MODx.config.server_offset_time,startDay: parseInt(MODx.config.manager_week_start),width: 250,dateWidth: 150}]}

                    ,{columnWidth:.3,items:[{xtype: 'textfield' ,fieldLabel: _('justknit.first_name') ,name: 'first_name'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield' ,fieldLabel: _('justknit.last_name')  ,name: 'last_name'}]}
                    ,{columnWidth:.3,items:[{xtype: 'textfield' ,fieldLabel: _('justknit.nick_name')  ,name: 'nick_name'}]}


                    //hidden fields
//                    ,{columnWidth:.3,items:[{xtype: 'hidden' ,fieldLabel: _('justknit.internalKey') ,name: 'internalKey'}]}
//                    ,{columnWidth:.3,items:[{xtype: 'hidden' ,fieldLabel: _('justknit.logincount') ,name: 'logincount'}]}
//                    ,{columnWidth:.3,items:[{xtype: 'hidden' ,fieldLabel: _('justknit.lastlogin') ,name: 'lastlogin'}]}
//                    ,{columnWidth:.3,items:[{xtype: 'hidden' ,fieldLabel: _('justknit.failedlogincount') ,name: 'failedlogincount'}]}
//                    ,{columnWidth:.3,items:[{xtype: 'hidden' ,fieldLabel: _('justknit.sid') ,name: 'sid'}]}
                ]
            })
        ]
    });
    JustKnit.window.CreateUpdateSubscriber.superclass.constructor.call(this, config);
    console.log('parseInt(config.active)'+parseInt(config.active));
    console.log('parseInt(config.record.active)'+parseInt(config.record.active));
};
Ext.extend(JustKnit.window.CreateUpdateSubscriber, MODx.Window);
Ext.reg('justknit-window-subscriber-create-update', JustKnit.window.CreateUpdateSubscriber);    




//        } ]

/* defaults:{border:false, layout: 'form',defaults:{xfield:"form",defaultType:'textfield',anchor:'95%'}}*/


/*

                  {columnWidth:.3,items:[{xtype: 'textfield' ,fieldLabel: _('justknit.username') ,name: 'username'  }]},
                  {columnWidth:.3,items:[{ xtype: 'textfield' ,fieldLabel: _('justknit.primary_group') ,name: 'primary_group'  }]},
                  {columnWidth:.3,items:[{ xtype: 'textfield' ,fieldLabel: _('justknit.internalKey') ,name: 'internalKey'  }]},
                  {columnWidth:.3,items:[{ xtype: 'textfield' ,fieldLabel: _('justknit.fullname') ,name: 'fullname'  }]},
                  {columnWidth:.3,items:[{ xtype: 'textfield' ,fieldLabel: _('justknit.email') ,name: 'email'  }]},
*/

/*
        ,fields: [{xtype:'fieldset',items :[
            {xtype: 'textfield' ,fieldLabel: _('justknit.username') ,name: 'username'  }
            ,{ xtype: 'textfield' ,fieldLabel: _('justknit.active') ,name: 'active'  }
            ]
        },{xtype:'fieldset',items :[
            ,{ xtype: 'textfield' ,fieldLabel: _('justknit.primary_group') ,name: 'primary_group'  }
            ,{ xtype: 'textfield' ,fieldLabel: _('justknit.internalKey') ,name: 'internalKey'  }
            ]
        }]
*/

/*        [{
				xtype:'fieldset',layout: 'column' //,layout: 'form'
                ,columnWidth: .5
				,bodyStyle: 'border: 1px solid green;'
				,items: [{xtype: 'textfield' ,fieldLabel: _('justknit.username') ,name: 'username' }
            ,{ xtype: 'textfield' ,fieldLabel: _('justknit.active') ,name: 'active' }
            ]
			},{
				//xtype: 'form',layout: 'hbox'
                layout: 'column'
				,bodyStyle: 'border: 1px solid red;'
				,items: [{ xtype: 'textfield' ,fieldLabel: _('justknit.internalKey') ,name: 'internalKey' }
            ,{ xtype: 'textfield' ,fieldLabel: _('justknit.fullname') ,name: 'fullname' }

            ]
			}]
*/
/*        [
            {
                xtype: 'panel'
                ,items:[
                    {
                        layout:'column'
                        ,columnWidth:.5
                        // ,layout:'form'
                        ,items:[
                            {
                                xtype: 'textfield'
                                ,fieldLabel: _('justknit.active')
                                ,name: 'active'

                            }
                            ,{
                                xtype: 'textfield'
                                ,fieldLabel: _('justknit.primary_group')
                                ,name: 'primary_group'

                            },
                { xtype: 'textfield' ,fieldLabel: _('justknit.id') ,name: 'id' ,anchor: '50%' }
            ,{ xtype: 'textfield' ,fieldLabel: _('justknit.subscriber_id') ,name: 'subscriber_id' ,anchor: '50%' }

                        ]
                    }
                ]
            }
            ,{
                xtype: 'panel'
                ,layout:'column'
                ,columnWidth:.3,
                layout:'form',
                items:[{ xtype: 'textfield' ,fieldLabel: _('justknit.internalKey') ,name: 'internalKey' ,anchor: '50%' }
            ,{ xtype: 'textfield' ,fieldLabel: _('justknit.fullname') ,name: 'fullname'
                ,anchor: '50%'
            }]}]
        */
    

/*
        }]
    });*/

/*
            {
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_s_id')
                ,name: 'id'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_id')
                ,name: 'subscriber_id'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_first_name')
                ,name: 'first_name'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_last_name')
                ,name: 'last_name'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_nick_name')
                ,name: 'nick_name'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_sid')
                ,name: 'sid'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_active_order')
                ,name: 'active_order'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_active_product')
                ,name: 'active_product'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_subscribedon')
                ,name: 'subscribedon'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_activatedon')
                ,name: 'activatedon'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_blockedafter')
                ,name: 'subscriber_blockedafter'
                ,anchor: '50%'
            }
            ,{
                xtype: 'xcheckbox'
                ,boxLabel: _('justknit.subscriber_blocked')
                ,hideLabel: true
                ,name: 'subscriber_blocked'
                ,anchor: '50%'
            }
            ,{
                xtype: 'xcheckbox'
                ,boxLabel: _('justknit.user_blocked')
                ,hideLabel: true
                ,name: 'blocked'
                ,anchor: '50%'
            }
            ,{
                xtype: 'textfield'
                ,fieldLabel: _('justknit.subscriber_deletedafter')
                ,name: 'subscriber_deletedafter'
                ,anchor: '50%'
            }
            ,{
                xtype: 'xcheckbox'
                ,hideLabel: true
                ,boxLabel: _('justknit.subscriber_deleted')
                ,name: 'subscriber_deleted'
                ,anchor: '50%'
            }
*/






