/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */
const KnApKey = 'knitApp';
const KnApDfVal = {
            gid: 0,
            sessionId: 0,
//            lastDisplayTime: 0,
//            returningVisitor: !1,
//            displayCount: 0,
//            dismissed: !1,
//            added: !1,
            sessions: 0,
//            nextSession: 0,
            theme: 'light'
};

/**
 * BEGIN Nachtmodus
 * Alles was mit dem Nachtmodus zu tun hat.
 *
 **/
const themeDisplay = document.getElementById("darkSwitchLabel");
const darkSwitch = document.getElementById("darkSwitch");
function getKnitApp() {
//   var KnitApp = (localStorage.getItem(KnApKey) !== null);
   (localStorage.getItem(KnApKey) !== null) ? KnitApp = JSON.parse(localStorage.getItem(KnApKey)) : KnitApp = KnApDfVal;
    return KnitApp;
//    JSON.parse(localStorage.getItem(KnApKey)) || KnApDfVal;
}
function updateKnitApp(kaVal) {
    localStorage.setItem(KnApKey, JSON.stringify(kaVal));
}
function initTheme() {
    var kaVal = getKnitApp();
    var darkThemeSelected = (kaVal !== null && kaVal.theme === 'dark');
    // update checkbox
    darkSwitch ? darkSwitch.checked = darkThemeSelected : null;
    darkThemeSelected ? document.documentElement.dataset.appliedMode = 'dark' : document.documentElement.dataset.appliedMode = 'light';
    updateKnitApp(kaVal);
}
setTimeout(() => {
    if(darkSwitch) {
        initTheme(); // on page load, if user has already selected a specific theme -> apply it
        /** TODO: themeDisplay muss dann noch mit dem lexiconstring gefüllt werden. **/
        darkSwitch.addEventListener('change', function(event){
            changeTheme();
        });
        function changeTheme() {
            var kaVal = getKnitApp();
            if(darkSwitch.checked) { // dark theme has been selected
                document.documentElement.dataset.appliedMode = 'dark';
                kaVal.theme = 'dark';
            } else {
                document.documentElement.dataset.appliedMode = 'light';
                kaVal.theme = 'light';
            }
            updateKnitApp(kaVal);
        };
    }
}, 1000);
/** END Nachtmodus **/
