<?php
/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */
use MODX\Revolution\modResource;
/**
 * GetId
 *
 * Snippet return id of requested alias or pagetitle.
 *
 * @var modX $modx
 * @var Calculate $calculate
 * @var array $scriptProperties
 *
 * @package justknit
 * @subpackage snippets
 */

$output = '';
$alias = isset($scriptProperties['alias']) ? $scriptProperties['alias'] : '';
$pagetitle = isset($scriptProperties['pagetitle']) ? $scriptProperties['pagetitle'] : '';

if ($alias) {
    $resourceObj = $modx->getObject(modResource::class, array('alias' => $alias));
}
if($pagetitle) {
    $resourceObj = $modx->getObject(modResource::class, array('pagetitle' => $pagetitle));
}
if ($resourceObj) {
    $output = $resourceObj->get('id');
}

return $output;
