<?php
/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */
use JustKnit\Register\Register;

/**
 * JustKnitRegister
 *
 * Snippet which handles new subscriptions and processes register forms.
 *
 * @var modX $modx
 * @var Register $register
 * @var array $scriptProperties
 */
/** 
 * @order_id string The ID of the order delivered by DS24.
 *                   (default: '')
 * @buyer_id string The ID of the user delivered by DS24.
 *                   (default: '')
 * @product_id string DS24 ID of product
 *                   (default: '') 
 * @invoice_url string url of invoice at Digistore24
 *                   (default: '') 
 * 
 * @package justknit
 * @subpackage snippets
 */
$register = new Register($modx, $scriptProperties);  // ruft auf: src/Register/Register.php
$controller = $register->loadController('ThankYouPageDS24');  //darin diese Funktion
$output = $controller->run($scriptProperties);
return $output;