<?php

/**
 * This file is part of the JustKnit package.
 *
 * @copyright zahlenhexe (Iris Hammer)
 * @license GNU General Public License v2.0 (and later)
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
/*
 * Fields:
 * 'DS24_id' => 0,
 * 'product_name' => '',
 * 'product_duration' => '',
 * 'modxusergroup' => 0,
 *
 */
namespace JustKnit\Processors\Calc;

use MODX\Revolution\Processors\Model\GetListProcessor;
use JustKnit\Model\JustKnitCalc;
use MODX\Revolution\modResource;
use MODX\Revolution\modDocument;
use xPDO\Om\xPDOQuery;
use xPDO\Om\xPDOObject;
use MODX\Revolution\modX;

class GetResourceList extends GetListProcessor {
    public $classKey = modResource::class;
    public $defaultSortField = 'id';
    
    public function prepareQueryBeforeCount(xPDOQuery $c) {
        $c->rightJoin(JustKnitCalc::class, 'JustKnitCalc', 'modResource.id = JustKnitCalc.resource_id');
        $flds = array('id','resource_id', 'alias');
        $c->select($this->modx->getSelectColumns(
                modResource::class,
                'modResource',
                '',
                $flds
            ));
        $c->select($this->modx->getSelectColumns(
                JustKnitCalc::class,
                'JustKnitCalc',
                '',
                $flds
            ));
        unset($flds);
//$c->prepare();
//$this->modx->log(modX::LOG_LEVEL_ERROR,'modResource $c: '. $c->toSQL());
        return $c;
    }
    public function prepareQueryAfterCount(xPDOQuery $c) {
        
        $flds = array('id','resource_id', 'alias');
        $c->select($this->modx->getSelectColumns(
                modResource::class,
                'modResource',
                '',
                $flds
            ));
        $c->select($this->modx->getSelectColumns(
                JustKnitCalc::class,
                'JustKnitCalc',
                '',
                $flds
            ));
//$c->prepare();
//$this->modx->log(modX::LOG_LEVEL_ERROR,'AfterCount $c: '. $c->toSQL());
        
        return $c;                
    }
    
}
/*
    public $classKey = JustKnitCalc::class;
    public $defaultSortField = 'id';
    public $defaultSortDirection = 'ASC';
    public $objectType = 'justknit.calc';
    
    public function prepareQueryBeforeCount(xPDOQuery $c) {
        $c->leftJoin(modResource::class, 'modResource', 'JustKnitCalc.resource_id = modResource.id');
    //`rv_justknit_calc`.`resource_id` = `rv_site_content`.`id`;
        $flds = array_keys($this->modx->getFields(JustKnitCalc::class));
        unset($flds['id']);
        $c->select($this->modx->getSelectColumns(
                JustKnitCalc::class,
                'JustKnitCalc',
                '',
                $flds
            ));
//$c->leftJoin(modResource::class, 'modResource', 'JustKnitCalc.resource_id = modResource.id');        
        $flds = array_keys($this->modx->getFields(modResource::class));
//        unset($flds['id']);
        $c->select($this->modx->getSelectColumns(
                modResource::class,
                'modResource',
                '',
                $flds
            ));
        $c->prepare();
$this->modx->log(modX::LOG_LEVEL_ERROR,'$c: '. $c->toSQL());

// SELECT `JustKnitCalc`.`id`, `JustKnitCalc`.`resource_id`, `modResource`.`alias` FROM `rv_site_content` AS `modResource` right JOIN `rv_justknit_calc` `JustKnitCalc` ON JustKnitCalc.resource_id = modResource.id 
        return $c;
    }
    public function prepareQueryAfterCount(xPDOQuery $c)
    {
        $flds = array_keys($this->modx->getFields(JustKnitCalc::class));
        unset($flds['id']);
        $c->select($this->modx->getSelectColumns(
                JustKnitCalc::class,
                'JustKnitCalc',
                '',
                $flds
            ));
        $flds = array_keys($this->modx->getFields(modResource::class));
        unset($flds['id']);
        $c->select($this->modx->getSelectColumns(
                modResource::class,
                'modResource',
                '',
                $flds
            ));
        $c->prepare();
$this->modx->log(modX::LOG_LEVEL_ERROR,'AfterCount $c: '. $c->toSQL());
        
        return $c;        
    }

}
*/
