<?php
/**
 * This file is part of the JustKnit package.
 *
 * @copyright JustKnit (Iris Hammer) <iris@justknit.de>
 * @license All rights reserved (@https://dejure.org/gesetze/UrhG/69a.html)
 * Created on 03-20-2023
 *
 * @package justknit
 */

namespace JustKnit\Processors\Calculate;

use JustKnit\Calculate\Calculate;
use MODX\Revolution\modX;
/**
 * Abstracts processors into a class.
 *
 * @package justknit
 * @subpackage processors
 */
abstract class Base {
    /** @var Calculate $calculate */
    public $calculate = null;

    /** @var object $controller */
    public $controller = null;

    /** @var Dictionary $dictionary */
    public $dictionary = null;

    /** @var array $config */
    public $config = [];
    /**
     * Constructor for the Base calculate processor.
     *
     * @param Calculate &$calculate A reference to the Calculate instance
     * @param object &$controller
     * @param array $config
     */
    public function __construct(Calculate &$calculate, &$controller, array $config = []) {
        $this->modx = &$calculate->modx;
        $this->calculate = &$calculate;
        $this->controller = &$controller;
        $this->dictionary = &$controller->dictionary;
        $this->config = array_merge($this->config, $config);
    }
    abstract public function process();
}
