<?php

/**
 * This file is part of the JustKnit package.
 *
 * @copyright zahlenhexe (Iris Hammer)
 * @license GNU General Public License v2.0 (and later)
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace JustKnit\Processors\Client;

use MODX\Revolution\Processors\Model\CreateProcessor;
use JustKnit\Model\JustKnitClientMeta;
use xPDO\Om\xPDOQuery;

class Create extends CreateProcessor {
    public $classKey = JustKnitClientMeta::class;
    public $objectType = 'justknit.client';
    /**
     * Override in your derivative class to do functionality before save() is run
     *
     * @return boolean
     */

    public function beforeSave()
    {
        $client_name = $this->getProperty('client_name');
        if (empty($client_name)) {
            $this->addFieldError('client_name', $this->modx->lexicon('justknit.client_err_missing_client_name'));
        }
    }

}

