<?php

/**
 * This file is part of the JustKnit package.
 *
 * @copyright zahlenhexe (Iris Hammer)
 * @license GNU General Public License v2.0 (and later)
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace JustKnit\Processors\Order;

use MODX\Revolution\Processors\Model\GetListProcessor;
use JustKnit\Model\JustKnitOrder;
use xPDO\Om\xPDOQuery;

class GetList extends GetListProcessor {

    public $classKey = JustKnitOrder::class;
    public $defaultSortField = 'id';
    public $defaultSortDirection = 'ASC';
    public $objectType = 'justknit.order';

    public function prepareQueryBeforeCount(xPDOQuery $c) {

        $flds = array_keys($this->modx->getFields(JustKnitOrder::class));
        $c->select($this->modx->getSelectColumns(
                JustKnitOrder::class,
                'JustKnitOrder',
                '',
                $flds
            ));
        unset($flds);
        $query = $this->getProperty('query');
        if (!empty($query)) {
            $c->where(
                [
                    'order_id:LIKE' => '%' . $query . '%'
                ]
            );
        }
        $activeorderfilter = $this->getProperty('activeorderfilter', '');
        if (!empty($activeorderfilter)) {
            if ($activeorderfilter) {
                $c->where(['JustKnitOrder.subscriptionend:>=' => time() ]);
//                $c->where(['product_id' => $activeorderfilter]);
//                $c->where(['product_id' => $activeorderfilter]);
//            } else {
//                $c->where(['User.primary_group' => $activeorderfilter]);
            }
        }
        $productfilter = $this->getProperty('productfilter', '');
        if (!empty($productfilter)) {
            if ($productfilter == 'nogroup') {
                $c->where(['product_id' => null]);
            } else {
                $c->where(['product_id' => $productfilter]);
            }
        }
        return $c;
    }



    //activeorderfilter

}
