<?php

/**
 * This file is part of the JustKnit package.
 *
 * @copyright zahlenhexe (Iris Hammer)
 * @license GNU General Public License v2.0 (and later)
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */
namespace JustKnit\Processors\Product;

use MODX\Revolution\Processors\Model\UpdateProcessor;
use JustKnit\Model\JustKnitProduct;
use xPDO\Om\xPDOQuery;

class Update extends UpdateProcessor {
    public $classKey = JustKnitProduct::class;
    public $objectType = 'justknit.product';
    /**
     * Override in your derivative class to do functionality before save() is run
     *
     * @return boolean
     */

    public function beforeSave()
    {
        $product_name = $this->getProperty('product_name');
        if (empty($product_name)) {
            $this->addFieldError('product_name', $this->modx->lexicon('justknit.product_err_missing_product_name'));
        }
        return parent::beforeSave();
    }

}

